Attribute VB_Name = "Modul1"
Option Explicit
Const TITEL = "Office Journal - Spalten/Zeilen tauschen"

Sub SpaltenZeilenTauschen()
                        Dim AnzahlSpalten As Integer
                        Dim AnzahlZeilen As Integer
                        Dim AnzahlSpaltenOrg As Integer
                        Dim AnzahlZeilenOrg As Integer
                        
                        Dim ZeilenZhler As Integer
                        Dim SpaltenZhler As Integer
                        Dim DatenFeld() As String
                        Dim Feldzhler As Integer
                        Dim Offsetzhler As Integer
                        Dim Zellenzhler As Integer
                        Dim EinfgeZhler As Integer

    'Sicherstellen, da Cursor in Tabelle positioniert ist
    If Selection.Information(wdWithInTable) = False Then
        MsgBox Prompt:="Der Cursor befindet sich zur Zeit in keiner Tabelle." & vbCr & _
                       "Die Spalten/Zeilen knnen nicht getauscht werden.", _
               Buttons:=vbCritical, _
               Title:=TITEL
        End
    End If
    
    AnzahlSpalten = Selection.Information(wdMaximumNumberOfColumns)
    AnzahlZeilen = Selection.Information(wdMaximumNumberOfRows)
    AnzahlSpaltenOrg = AnzahlSpalten
    AnzahlZeilenOrg = AnzahlZeilen
    
    'Sicherstellen, da die Tabelle gre wie eine Zeile und eine Spalte ist
    If AnzahlSpalten = 1 Then
        MsgBox Prompt:="Ihr Tabelle besteht aus nur einer Spalte." & vbCr & _
                       "Die Spalten/Zeilen knnen nicht getauscht werden.", _
               Buttons:=vbCritical, _
               Title:=TITEL
        End
    End If
    If AnzahlZeilen = 1 Then
        MsgBox Prompt:="Ihr Tabelle besteht aus nur einer Zeile." & vbCr & _
                       "Die Spalten/Zeilen knnen nicht getauscht werden.", _
               Buttons:=vbCritical, _
               Title:=TITEL
        End
    End If
    
    'Tabelle "quadratisch machen"
    If AnzahlSpalten <> AnzahlZeilen Then
        If AnzahlSpalten > AnzahlZeilen Then
            'Mehr Spalten wie Zeilen -> Zeilen hinzufgen
            'Cursor in letzte Zelle
            While Selection.Information(wdStartOfRangeRowNumber) <> AnzahlZeilen
                Selection.MoveDown Unit:=wdLine, Count:=1
            Wend
            While Selection.Information(wdStartOfRangeColumnNumber) <> AnzahlSpalten
                Selection.MoveRight Unit:=wdCell
            Wend
            
            'Zeilen einfgen
            For EinfgeZhler = 1 To (AnzahlSpalten - AnzahlZeilen) * (AnzahlSpalten - 1)
                Selection.MoveRight Unit:=wdCell
            Next EinfgeZhler
        Else
            'Mehr Zeilen wie Spalten -> Spalten hinzufgen
            'Cursor in letzte Spalte
            If Selection.Information(wdStartOfRangeColumnNumber) <> AnzahlSpalten Then
                While Selection.Information(wdStartOfRangeColumnNumber) <> AnzahlSpalten
                    Selection.MoveRight Unit:=wdCell
                Wend
            Else
                Selection.MoveLeft Unit:=wdCell
                Selection.MoveRight Unit:=wdCell
            End If
            Selection.MoveRight Unit:=wdCharacter, Count:=2
            
            'Spalten einfgen
            For EinfgeZhler = 1 To (AnzahlZeilen - AnzahlSpalten)
                Selection.InsertColumns
            Next EinfgeZhler
        End If
        
        'Neue Zeilen/Spalten-Zahl speichern
        AnzahlSpalten = Selection.Information(wdMaximumNumberOfColumns)
        AnzahlZeilen = Selection.Information(wdMaximumNumberOfRows)
    End If
    
    'Feld dimensionieren
    Dim AnzahlFelder As Integer
    AnzahlFelder = AnzahlSpalten * AnzahlZeilen
    ReDim DatenFeld(AnzahlFelder)
    
    'Cursor in erste Zelle
    While Selection.Information(wdStartOfRangeRowNumber) > 1
        Selection.MoveUp Unit:=wdLine, Count:=1
    Wend
    While Selection.Information(wdStartOfRangeColumnNumber) > 1
        Selection.MoveLeft Unit:=wdCell
    Wend

    'Felder der Reihe nach durchgehen und auslesen
    Feldzhler = 1
    For ZeilenZhler = 1 To AnzahlZeilen
        For SpaltenZhler = 1 To AnzahlSpalten
            DatenFeld(Feldzhler) = Selection.Text
            Feldzhler = Feldzhler + 1
            If Feldzhler <= AnzahlFelder Then
                Selection.MoveRight Unit:=wdCell
            End If
        Next SpaltenZhler
        'Selection.MoveRight Unit:=wdCell
    Next ZeilenZhler

    'Cursor wieder in erste Zelle
    While Selection.Information(wdStartOfRangeRowNumber) > 1
        Selection.MoveUp Unit:=wdLine, Count:=1
    Wend
    While Selection.Information(wdStartOfRangeColumnNumber) > 1
        Selection.MoveLeft Unit:=wdCell
    Wend

    'Daten vertauscht in Tabelle einfgen
    Feldzhler = 1
    Offsetzhler = 0
    Zellenzhler = 1
    For ZeilenZhler = 1 To AnzahlZeilen
        For SpaltenZhler = 1 To AnzahlSpalten
            Selection.Text = DatenFeld(Feldzhler + Offsetzhler)
            Offsetzhler = Offsetzhler + AnzahlSpalten
            If Zellenzhler < AnzahlFelder Then
                Selection.MoveRight Unit:=wdCell
                Zellenzhler = Zellenzhler + 1
            End If
        Next SpaltenZhler
        Feldzhler = Feldzhler + 1
        Offsetzhler = 0
    Next ZeilenZhler
    
    'Cursor in erste Zelle
    While Selection.Information(wdStartOfRangeRowNumber) > 1
        Selection.MoveUp Unit:=wdLine, Count:=1
    Wend
    While Selection.Information(wdStartOfRangeColumnNumber) > 1
        Selection.MoveLeft Unit:=wdCell
    Wend
    
    'Eventuell hinzugefgt Spalten/Zeilen wieder entfernen
    If AnzahlSpaltenOrg <> AnzahlSpalten Then
        'Zeilen lschen
        Selection.MoveDown Unit:=wdLine, Count:=AnzahlSpaltenOrg
        For EinfgeZhler = 1 To (AnzahlZeilen - AnzahlSpaltenOrg)
            Selection.Rows.Delete
        Next EinfgeZhler
    End If
    
    If AnzahlZeilenOrg <> AnzahlZeilen Then
        'Spalten lschen
        Selection.MoveRight Unit:=wdCell, Count:=AnzahlZeilenOrg
        For EinfgeZhler = 1 To (AnzahlSpalten - AnzahlZeilenOrg)
            Selection.Columns.Delete
        Next EinfgeZhler
        
    End If
    
End Sub
